//change these directories!
global direct="C:\Users\Ned\Dropbox\Time Discounting Experiment_OWN\StataExample"
cd "$direct"
clear

// Parameters driving decisions - these are ballpark what I seem to find - modify to see what happens!
local beta=.9
local delta=.99
local phi=250
local sigma=20
local gamma=1.95

//gen 100 different workers with worker ids -> let's give them different phis (if want them to have same phi, just change rnormal(0,50) to rnormal(0,0))
set obs 100
gen wid=_n
gen phi_i=max(10,round(`phi'+rnormal(0,0)))
 
//for each worker, generate 100 observations
expand 100
sort wid

//for each observation, generate wage between $.01 and $.30:
gen wage=(floor((30)*runiform() + 1))/100

//each observation, have different distances from work with a bunch of 0s (ie today) as in the data:
gen distanceToWork=(floor((30)*runiform() -9))
replace distanceToWork=0 if distanceToWork<0
gen today=(distanceToWork==0)

//let's make it simple and have a constant payment date:
gen distanceToPayment=40

//what is person's decision given: 
//benefit: e*w (discounted if we want, by delta^paymentDate - this will only effect estimate of phi) 
//cost: (1/gamma)*(1/phi)*e^gamma?
//=>this is decision if not today:
gen optimalDecision=(((`delta'^distanceToPayment)*phi_i*wage)/(`beta'*(`delta'^ distanceToWork)))^(1/(`gamma'-1))
//=>this is decision if today:
replace optimalDecision=(((`delta'^distanceToPayment)*phi_i*wage)/(1))^(1/(`gamma'-1)) if  distanceToWork==0

//now add some decision error and round
gen observedDecisionNoTruncation=round(optimalDecision+rnormal(0,`sigma'))

//one issue: we observe truncated decision sometimes
gen observedDecision=observedDecisionNoTruncation
replace observedDecision=100 	if  observedDecision>100
replace observedDecision=0 		if  observedDecision<0

save simulatedData, replace

