clear all
use "simulatedData", clear

// ** NL (with very slightly different results):
// Much easier code to do simple estimation.
// The issue with NL is its much harder to do more complicated stuff.
nl (observedDecisionNoTruncation = ( (({beta}^(today))*({delta}^(distanceToPayment))*{phi}*wage)/{delta}^(distanceToWork))^(1/ ({gamma}-1)) ) ///
, init(beta 1 delta 1 phi 2 gamma 2)
	
	
// ** MLE code	
//I like to define globals that pass to the ML_ADO_file to control the estimation. For example, here tobit=1 implies Tobit correction and tobit=0 does not
global tobit=1													//if you set this =0 and have trucated data, your estimates will be off! Note: If you don't use Tobit you will be fine if you observed true data (ie replace observedDecision=observedDecisionNoTruncation)
global setupvarsPassedToADO="sigma delta phi gamma beta" 		//these are the vars we are estimating - gets passed to ML_ADO

//to make it a little easier to read and change/cycle through, I also separate the pieces of the "ml model" command into globals  
global dataToUse="observedDecision distanceToWork distanceToPayment wage today"				//these are variables we are using in the estimation
global init="ml init beta:_cons=1 gamma:_cons=2 delta:_cons=1 phi:_cons=100 sigma:_cons=30" //These are the initial guesses to pass to ML routine - doesn't effect end estimation, but good to start with feasible values so it converges
global varsToEstimate="(delta:) (phi:) (gamma:) (beta:)" 									//these are the vars we are estimating MINUS SIGMA, which is hard coded into the ML command

//Note: you generate dummys and modify varsToEstimate, easy to estimate individual worker phis
	//qui tab wid, gen(wid_) 
	//global varsToEstimate="(delta:) (phi: wid_*) (gamma:) (beta:)" 									//these are the vars we are estimating REMOVING SIGMA, which is hard coded into the ML command

//run model using ML_ADO_file
ml model lf ML_ADO_file (sigma: $dataToUse =) $varsToEstimate if (1==1), clu(wid) technique(nr) 
$init
ml max


