program ML_ADO_file
	version 9.1
	args lnf $setupvarsPassedToADO
	//tempvar defines variables you want to name and create in this file in addition to $dataToUse
	tempvar $dataToUse predchoice prob
	
	//you have to pass all of your variables in $dataToUse in the exact order. Could automate, but nice to see written out
	qui gen double `observedDecision'=$ML_y1
	qui gen double `distanceToWork'=$ML_y2
	qui gen double `distanceToPayment'=$ML_y3
	qui gen double `wage'=$ML_y4
	qui gen double `today'=$ML_y5

	//this is our predicted choice of the person given the variables we start with
	qui gen double `predchoice'=(((`delta'^`distanceToPayment')*`phi'*`wage')/(`beta'*(`delta'^`distanceToWork')))^(1/(`gamma'-1)) 			//this is decision if not today
	qui replace    `predchoice'=(((`delta'^`distanceToPayment')*`phi'*`wage')/(1))^(1/(`gamma'-1)) if `today'==1						    //this is decision if today
	
	//this is the probability of the decision given our error structure
	qui gen double `prob'=normalden(`observedDecision',`predchoice',`sigma')
	
	//tobit correction
	if ($tobit) { 				
		qui replace `prob'=1-normal((`predchoice'-(`observedDecision'))/`sigma') if `observedDecision'==0
		qui replace `prob'=normal((`predchoice'-(`observedDecision'))/`sigma') if `observedDecision'==100
	}
	
	//need this for MLE to cycle through
	quietly replace `lnf' = ln(`prob')
	
end





